Codeforces 913D - Too Easy Problems(贪心+优先队列)

You are preparing for an exam on scheduling theory. The exam will last for exactly T milliseconds and will consist of n problems. You can either solve problem i in exactly ti milliseconds or ignore it and spend no time. You don't need time to rest after solving a problem, either.

Unfortunately, your teacher considers some of the problems too easy for you. Thus, he assigned an integer ai to every problem i meaning that the problem i can bring you a point to the final score only in case you have solved no more than ai problems overall (including problem i).

Formally, suppose you solve problems p1, p2, ..., pk during the exam. Then, your final score s will be equal to the number of values of j between 1 and k such that k ≤ apj.

You have guessed that the real first problem of the exam is already in front of you. Therefore, you want to choose a set of problems to solve during the exam maximizing your final score in advance. Don't forget that the exam is limited in time, and you must have enough time to solve all chosen problems. If there exist different sets of problems leading to the maximum final score, any of them will do.

Input

The first line contains two integers n and T (1 ≤ n ≤ 2·105; 1 ≤ T ≤ 109) — the number of problems in the exam and the length of the exam in milliseconds, respectively.

Each of the next n lines contains two integers ai and ti (1 ≤ ai ≤ n; 1 ≤ ti ≤ 104). The problems are numbered from 1 to n.

Output

In the first line, output a single integer s — your maximum possible final score.

In the second line, output a single integer k (0 ≤ k ≤ n) — the number of problems you should solve.

In the third line, output k distinct integers p1, p2, ..., pk (1 ≤ pi ≤ n) — the indexes of problems you should solve, in any order.

If there are several optimal sets of problems, you may output any of them.

Example
Input
5 300
3 100
4 150
4 80
2 90
2 300
Output
2
3
3 1 4
Input
2 100
1 787
2 788
Output
0
0

Input
2 100
2 42
2 58
Output
2
2
1 2
Note

In the first example, you should solve problems 3, 1, and 4. In this case you'll spend 80 + 100 + 90 = 270 milliseconds, falling within the length of the exam, 300 milliseconds (and even leaving yourself 30 milliseconds to have a rest). Problems 3 and 1 will bring you a point each, while problem 4 won't. You'll score two points.

In the second example, the length of the exam is catastrophically not enough to solve even a single problem.

In the third example, you have just enough time to solve both problems in 42 + 58 = 100 milliseconds and hand your solutions to the teacher with a smile.

题目大意,给你n个题目,并且将n个题目的时间也给了你,问:在给定时间内,你最多得到多少分,分数的计算是你完成了m道题目,这m道题目里面由给定的a[i](1<=i<=m),如果a[i]>=m,就得到一分否则不得分

这题目很坑,从样例1就开始坑了,因为题目中说的是只要求出最多分数,然后把一定要取得取出来就看可以了,但我们看看样例1,第四个题目 2 90 对它们实际对分数有没有任何帮助?其实是没有的,因此 当a[i]

说说题解;先用贪心思想,因为要在规定时间,故我们取t小的题目,先从小到大按时间排序,然后在建立一个优先队列,优先级一定要弄清楚,优先级应该以a[i]为关键词,我就是弄错了debug半天,当a[i]==a[j]时,按时间由大到小放弃,应该放弃时间多的,往后才能做更多的题目;如果不等,按a[i]由小到大排序,小的一定时对总分没有帮助的,弃掉,当a[i]>m时,我们才能入队列,然后当a[i]

#include 
#include 
#include 
#include 
#include 

using namespace std;
struct node
{
    int i;
    int x;//它的值
    int t;
    friend bool operator<(node a ,node b)
    {
        //和sort函数相反
        if(a.x!=b.x) return a.x>b.x;//时间相等,排除值小的
        else return a.t q;
int main()
{
    int i,j,n,count=0,t;
     node temp;
    scanf("%d%d",&n,&t);
    for(i=0; i<=n-1; i++)
    {
        scanf("%d%d",&a[i].x,&a[i].t);
        a[i].i=i+1;
    }
    sort(a,a+n,cmp);
    for(i=0; i<=n-1; i++)
    {
        if(t-a[i].t<0) break;
        if(a[i].x>count)
        {
            t-=a[i].t;
            q.push(a[i]);
            count++;
        }
        temp=q.top();
        //printf("%d %d\n",temp.x,count);
        while(!q.empty()&&temp.x

你可能感兴趣的:(贪心,优先队列)